import os # フォルダを扱うのに必要
import numpy as np # 配列を扱うのに必要
import matplotlib.pyplot as plt # 画像の表示に必要
import nibabel as nib # nifti画像の読み込みに必要
from tqdm import tqdm # おまけ。プログレスバー表示機能

img = nib.load('test.nii.gz') # 表示したい元画像の読み込み
image_data = img.get_data() # データを配列に収める
npimg=np.array(image_data) # 取得したデータを改めてNumpyの配列に収める
print(image_data.shape) # (x,y,z)を表示

print('一辺の長さを入力してください。[単位：pixel]')
pixel=int(input()) # 切り出す一片の長さを指定

# もともと横を向いていた画像を正常な向きに戻す作業
A=npimg.swapaxes(1,0) # (x,y,z)を(0,1,2)と考えてxとy(=0と1)を入れ替えた
B=A[-1::-1,:,:] # 元の(x,y,z)を(y,x,z)とした後に、yのみ逆順にした。最終要素である[-1]から-1ずつインデックスをずらすことにより実現

# 画像内のデータを表示する
print('最大値：'+str(np.max(B))+ ', 最小値：'+str(np.min(B))+ ', 平均値：'+str(np.mean(B)))

# 閾値を設定し、それ以下の値を"0"にする
print('閾値を入力してください。')
threshold=int(input()) # 閾値を指定
pic=B*(B>threshold) # B>thresholdは指定した閾値以上ならTrue、以下ならFalseのbool配列

# 実際に画像を保存する作業
os.mkdir('Results_A') # 保存用のフォルダを作成した
os.mkdir('Results_B')
for i in tqdm(range(pic.shape[2])): # このようにすることによって、ループを画像の枚数分だけ回せる
    for j in range(pic.shape[1]//pixel): # 端っこの余りを無視して四角く切り出せるrange
        x=pixel*j # x,yがそれぞれ指定の数だけ進む
        for k in range(pic.shape[0]//pixel): # 端っこの余りを無視して四角く切り出せるrange
            y=pixel*k
            save_pic = pic[y:y+pixel, x:x+pixel, i]  # 収めた配列から必要な部分だけを抽出する
            if(np.max(save_pic)==255):
                plt.imsave('Results_A/img' + str(i + 1) + '_x' + str(j + 1) + '_y' + str(k + 1) + '.jpg', save_pic, cmap=plt.cm.gray)
            else:
                plt.imsave('Results_B/img' + str(i + 1) + '_x' + str(j + 1) + '_y' + str(k + 1) + '.jpg', save_pic, cmap=plt.cm.gray)
